aboutsummaryrefslogtreecommitdiffstats
path: root/package/dropbear/files
diff options
context:
space:
mode:
authorJo-Philipp Wich <jow@openwrt.org>2011-07-31 12:05:54 +0000
committerJo-Philipp Wich <jow@openwrt.org>2011-07-31 12:05:54 +0000
commit8fc2981bcd63547d9e45896a261918342e8137aa (patch)
tree95a485f4753c3ee2648cd615d547174219d000a7 /package/dropbear/files
parent19eaf1c5f78afb7133e9208dd4d94938c19b3d08 (diff)
downloadupstream-8fc2981bcd63547d9e45896a261918342e8137aa.tar.gz
upstream-8fc2981bcd63547d9e45896a261918342e8137aa.tar.bz2
upstream-8fc2981bcd63547d9e45896a261918342e8137aa.zip
dropbear: - split port argument at the rightmost colon, allows binding to specific IPv6 addresses - don't use uci ipaddr var but resolve ifname and get addresses from it (#9853)
SVN-Revision: 27843
Diffstat (limited to 'package/dropbear/files')
-rwxr-xr-xpackage/dropbear/files/dropbear.init30
1 files changed, 25 insertions, 5 deletions
diff --git a/package/dropbear/files/dropbear.init b/package/dropbear/files/dropbear.init
index aa7e07dd6d..d06d2d5349 100755
--- a/package/dropbear/files/dropbear.init
+++ b/package/dropbear/files/dropbear.init
@@ -12,6 +12,27 @@ EXTRA_HELP=" killclients Kill ${NAME} processes except servers and yourself"
dropbear_start()
{
+ append_ports()
+ {
+ local ifname="$1"
+ local port="$2"
+
+ grep -qs "^ *$ifname:" /proc/net/dev || {
+ append args "-p $port"
+ return
+ }
+
+ for addr in $(
+ ifconfig "$ifname" | sed -ne '
+ /addr: *fe[89ab][0-9a-f]:/d
+ s/.* addr: *\([0-9a-f:\.]*\).*/\1/p
+ '
+ ); do
+ append args "-p $addr:$port"
+ done
+ }
+
+
local section="$1"
# check if section is enabled (default)
@@ -33,13 +54,12 @@ dropbear_start()
config_get_bool val "${section}" PasswordAuth 1
[ "${val}" -eq 0 ] && append args "-s"
# B) listen interface and port
+ local port
local interface
- local address
config_get interface "${section}" Interface
- config_get address "${interface}" ipaddr
- config_get val "${section}" Port
- val="${address:+${address}:}${val}"
- [ -n "${val}" ] && append args "-p ${val}"
+ config_get interface "${interface}" ifname "$interface"
+ config_get port "${section}" Port 22
+ append_ports "$interface" "$port"
# C) banner file
config_get val "${section}" BannerFile
[ -f "${val}" ] && append args "-b ${val}"